; EventConnection Library For PureBasic 
; (c) 2003 - Franco's EventConnection Library
;
; works with PureBasic v3.7
;
;
;- Start Main

NewMenu.l   = OnEvent(?MenuNew)
OpenMenu.l  = OnEvent(?MenuOpen)
SaveMenu.l  = OnEvent(?MenuSave)
NewToolbar.l  = OnEvent(?MenuNew)
OpenToolbar.l = OnEvent(?MenuOpen)
SaveToolbar.l = OnEvent(?MenuSave)
MyButton1.l = OnEvent(?Button1)
MyButton2.l = OnEvent(?Button2)
MyButton3.l = OnEvent(?Button3)
ChangebleStaticText = NoEvent()

If OpenWindow(1,100,200,320,240,#PB_Window_SystemMenu | #PB_Window_SizeGadget,"Test") = 0 : End : EndIf

CreateGadgetList(WindowID(1))
AdvancedGadgetEvents(#TRUE)

CreateMenu(1,WindowID(1))
  MenuTitle("File")
  MenuItem(NewMenu,"New")
  MenuItem(OpenMenu,"Open")
  MenuItem(SaveMenu,"Save")
  
CreateToolBar(1,WindowID(1))
  ToolBarStandardButton(NewToolbar,#PB_ToolBarIcon_New)
  ToolBarStandardButton(OpenToolbar,#PB_ToolBarIcon_Open)
  ToolBarStandardButton(SaveToolbar,#PB_ToolBarIcon_Save)
      
ButtonGadget(MyButton1,10,30,100,25,"Button 1")
ButtonGadget(MyButton2,10,80,100,25,"Button 2")

TextGadget(ChangebleStaticText, 120, 80, 200, 25, "Static Text with no Event but Auto Count")

TextGadget(NoEvent(), 120, 130, 200, 25, "Static Text with no Event but Auto Count")

ButtonGadget(MyButton3,10,130,100,25,"Button 3")


Repeat
  Event.l = WaitWindowEvent()
  
  Select Event
    Case #PB_Event_Menu
      CallEventFunction(EventMenuID())

    Case #PB_Event_Gadget
      CallEventFunction(EventGadgetID())
      
  EndSelect
Until Event = #PB_Event_CloseWindow

End

;- User Functions

Procedure TestMenu(Menu)
  MessageRequester("Test", "MenuItem #: " + Str(Menu),0)
EndProcedure

Procedure TestButton(Gadget)
  MessageRequester("Test", "Gadget #: " + Str(Gadget),0)
EndProcedure

MenuNew:
  TestMenu(Newmenu)
Return

MenuOpen:
  DisableMenuItem(OpenMenu,1)     ; disable the second menu item (Save)
  TestMenu(OpenMenu)
Return

MenuSave:
  If GetMenuItemState(1, SaveMenu) = 1   ; actual item state = check marked 
    SetMenuItemState(1, SaveMenu,0)      ; now remove the check mark 
  Else                                       ; actual item state = no check mark 
    SetMenuItemState(1, SaveMenu,1)      ; now set the check mark 
  EndIf 
  TestMenu(SaveMenu)
Return

Button1:
  If EventType() = #PB_EventType_LeftClick
    MessageRequester("Test PB_EventType_LeftClick", "Gadget #: " + Str(MyButton1),0)
  ElseIf EventType() = #PB_EventType_RightClick
    MessageRequester("Test PB_EventType_RightClick", "Gadget #: " + Str(MyButton1),0)
  EndIf
Return

Button2:
  If EventType() = #PB_EventType_LeftClick
    TestButton(MyButton2)
  EndIf
Return

Button3:
  If EventType() = #PB_EventType_LeftClick
    TestButton(MyButton3)
    SetGadgetText(ChangebleStaticText, "Text changed") 
  EndIf
Return
; ExecutableFormat=
; FirstLine=1
; EOF