; EventConnection Library For PureBasic 
; (c) 2003 - Franco's EventConnection Library
;
; works with PureBasic v3.7
;
;
;- Start Main

#MainWindow = 1
#ChildWindow = 2

NewMenu1.l   = OnEvent(?MenuNew1)
OpenMenu1.l  = OnEvent(?MenuOpen1)
SaveMenu1.l  = OnEvent(?MenuSave1)
NewToolbar1.l  = OnEvent(?MenuNew1)
OpenToolbar1.l = OnEvent(?MenuOpen1)
SaveToolbar1.l = OnEvent(?MenuSave1)
MyButton1.l = OnEvent(?Button1)
MyButton2.l = OnEvent(?Button2)
MyButton3.l = OnEvent(?Button3)
ChangebleStaticText1 = NoEvent()

NewMenu2.l : NewMenu2 = OnEvent(?MenuNew2)
OpenMenu2.l : OpenMenu2 = OnEvent(?MenuOpen2)
SaveMenu2.l : SaveMenu2 = OnEvent(?MenuSave2)
NewToolbar2.l : NewToolbar2 = OnEvent(?MenuNew2)
OpenToolbar2.l : OpenToolbar2 = OnEvent(?MenuOpen2)
SaveToolbar2.l : SaveToolbar2 = OnEvent(?MenuSave2)
MyButton4.l : MyButton4 = OnEvent(?Button4)
MyButton5.l : MyButton5 = OnEvent(?Button5)
MyButton6.l : MyButton6 = OnEvent(?Button6)
ChangebleStaticText2.l : ChangebleStaticText2 = NoEvent()

If OpenWindow(#MainWindow,100,200,320,240,#PB_Window_SystemMenu | #PB_Window_SizeGadget,"Main Window") = 0 : End : EndIf

CreateGadgetList(WindowID(#MainWindow))

AdvancedGadgetEvents(#TRUE)

UseGadgetList(WindowID(#MainWindow))

CreateMenu(1,WindowID(#MainWindow))
  MenuTitle("File")
  MenuItem(NewMenu1,"New")
  MenuItem(OpenMenu1,"Open")
  MenuItem(SaveMenu1,"Save")
  
CreateToolBar(1,WindowID(#MainWindow))
  ToolBarStandardButton(NewToolbar1,#PB_ToolBarIcon_New)
  ToolBarStandardButton(OpenToolbar1,#PB_ToolBarIcon_Open)
  ToolBarStandardButton(SaveToolbar1,#PB_ToolBarIcon_Save)
      
ButtonGadget(MyButton1,10,30,100,25,"Button 1")
ButtonGadget(MyButton2,10,80,100,25,"Button 2")

TextGadget(ChangebleStaticText1, 120, 80, 200, 25, "Static Text with no Event but Auto Count")

TextGadget(NoEvent(), 120, 130, 200, 25, "Static Text with no Event but Auto Count")

ButtonGadget(MyButton3,10,130,100,25,"Button 3")


Repeat
  Event.l = WaitWindowEvent()
  
  Select Event
    Case #PB_Event_Menu
      CallEventFunction(EventMenuID())

    Case #PB_Event_Gadget
      CallEventFunction(EventGadgetID())
      
    Case #PB_Event_CloseWindow
      If EventWindowID() > #MainWindow
        CloseWindow(EventWindowID())
      EndIf

  EndSelect

Until Event = #PB_Event_CloseWindow And EventWindowID() = #MainWindow

End

;- User Functions

Procedure TestMenu(Menu)
  MessageRequester("Test", "MenuItem #: " + Str(Menu),0)
EndProcedure

Procedure TestButton(Gadget)
  MessageRequester("Test", "Gadget #: " + Str(Gadget),0)
EndProcedure

CreateChildWindow:

  If OpenWindow(#ChildWindow,200,300,320,240,#PB_Window_SystemMenu | #PB_Window_SizeGadget,"Child Window") = 0 : End : EndIf

  CreateGadgetList(WindowID(#ChildWindow))
  AdvancedGadgetEvents(#TRUE)


  UseGadgetList(WindowID(#ChildWindow))

  CreateMenu(2,WindowID(#ChildWindow))
    MenuTitle("File")
    MenuItem(NewMenu2,"New")
    MenuItem(OpenMenu2,"Open")
    MenuItem(SaveMenu2,"Save")
  
  CreateToolBar(2,WindowID(#ChildWindow))
    ToolBarStandardButton(NewToolbar2,#PB_ToolBarIcon_New)
    ToolBarStandardButton(OpenToolbar2,#PB_ToolBarIcon_Open)
    ToolBarStandardButton(SaveToolbar2,#PB_ToolBarIcon_Save)
      
  ButtonGadget(MyButton4,10,30,100,25,"Button 4")
  ButtonGadget(MyButton5,10,80,100,25,"Button 5")

  TextGadget(ChangebleStaticText2, 120, 80, 200, 25, "Static Text with no Event but Auto Count")

  TextGadget(NoEvent(), 120, 130, 200, 25, "Static Text with no Event but Auto Count")

  ButtonGadget(MyButton6,10,130,100,25,"Button 6")
Return

MenuNew1:
  TestMenu(NewMenu1)
Return

MenuOpen1:
  DisableMenuItem(OpenMenu1,1)     ; disable the second menu item (Save)
  TestMenu(OpenMenu1)
Return

MenuSave1:
  If GetMenuItemState(1, SaveMenu1) = 1   ; actual item state = check marked 
    SetMenuItemState(1, SaveMenu1,0)      ; now remove the check mark 
  Else                                       ; actual item state = no check mark 
    SetMenuItemState(1, SaveMenu1,1)      ; now set the check mark 
  EndIf 
  TestMenu(SaveMenu1)
Return


MenuNew2:
  TestMenu(NewMenu2)
Return

MenuOpen2:
  DisableMenuItem(OpenMenu2,1)     ; disable the second menu item (Save)
  TestMenu(OpenMenu2)
Return

MenuSave2:
  If GetMenuItemState(2, SaveMenu2) = 1   ; actual item state = check marked 
    SetMenuItemState(2, SaveMenu2,0)      ; now remove the check mark 
  Else                                       ; actual item state = no check mark 
    SetMenuItemState(2, SaveMenu2,1)      ; now set the check mark 
  EndIf 
  TestMenu(SaveMenu2)
Return


Button1:
  If EventType() = #PB_EventType_LeftClick
    MessageRequester("Test PB_EventType_LeftClick", "Gadget #: " + Str(MyButton1),0)
  ElseIf EventType() = #PB_EventType_RightClick
    MessageRequester("Test PB_EventType_RightClick", "Gadget #: " + Str(MyButton1),0)
  EndIf
Return

Button2:
  If EventType() = #PB_EventType_LeftClick
    TestButton(MyButton2)
    Gosub CreateChildWindow
  EndIf
Return

Button3:
  If EventType() = #PB_EventType_LeftClick
    TestButton(MyButton3)
    SetGadgetText(ChangebleStaticText1, "Text changed") 
  EndIf
Return

Button4:
  If EventType() = #PB_EventType_LeftClick
    MessageRequester("Test PB_EventType_LeftClick", "Gadget #: " + Str(MyButton4),0)
  ElseIf EventType() = #PB_EventType_RightClick
    MessageRequester("Test PB_EventType_RightClick", "Gadget #: " + Str(MyButton4),0)
  EndIf
Return

Button5:
  If EventType() = #PB_EventType_LeftClick
    TestButton(MyButton5)
  EndIf
Return

Button6:
  If EventType() = #PB_EventType_LeftClick
    TestButton(MyButton6)
    SetGadgetText(ChangebleStaticText2, "Text changed") 
  EndIf
Return
; ExecutableFormat=
; CursorPosition=9
; FirstLine=41
; EOF